import os
import subprocess
import tkinter as tk
import ttkbootstrap as ttk

pwin = ttk.Window(themename="darkly")
pwin.title("Suggested Packages")
pwin.resizable(False, False)
WINDOW_HEIGHT = 470
WINDOW_WIDTH = 470

def center_screen():
    """ gets the coordinates of the center of the screen """
    screen_width = pwin.winfo_screenwidth()
    screen_height = pwin.winfo_screenheight()
    # Coordinates of the upper left corner of the window to make the window
    # appear in the center
    x_cordinate = int((screen_width / 2) - (WINDOW_WIDTH / 2))
    y_cordinate = int((screen_height / 2) - (WINDOW_HEIGHT / 2))
    pwin.geometry("{}x{}+{}+{}".format(WINDOW_WIDTH,
                   WINDOW_HEIGHT, x_cordinate, y_cordinate))

def check_packages(pdf_viewer, snap, media_player, fire_wall, flatpak, backup_tool, store):
    """ Check if software is installed"""
    if os.path.exists('/usr/bin/atril'):
        pdf_viewer['state'] = tk.DISABLED
    if os.path.exists('/usr/bin/snap'):
        snap['state'] = tk.DISABLED
    if os.path.exists('/usr/bin/parole'):
        media_player['state'] = tk.DISABLED
    if os.path.exists('/usr/bin/gufw'):
        fire_wall['state'] = tk.DISABLED
    if os.path.exists('/usr/bin/flatpak'):
        flatpak['state'] = tk.DISABLED
    if os.path.exists('/usr/bin/timeshift'):
        backup_tool['state'] = tk.DISABLED
    if os.path.exists('/usr/bin/gnome-software'):
        store['state'] = tk.DISABLED

def check_web_browsers(fire_fox, kde_web, qute_web, falkon_web, chromium_web, gnome_web, store):
    """ Check what browsers are installed"""
    if os.path.exists('/usr/bin/firefox'):
        fire_fox['state'] = tk.DISABLED
    if os.path.exists('/usr/bin/konqueror'):
        kde_web['state'] = tk.DISABLED
    if os.path.exists('/usr/bin/qutebrowser'):
        qute_web['state'] = tk.DISABLED
    if os.path.exists('/usr/bin/falkon'):
        falkon_web['state'] = tk.DISABLED
    if os.path.exists('/usr/bin/chromium'):
        chromium_web['state'] = tk.DISABLED
    if os.path.exists('/usr/bin/epiphany-browser'):
        gnome_web['state'] = tk.DISABLED
    if os.path.exists('/usr/bin/gnome-software'):
        store['state'] = tk.DISABLED

# ***GUI widgets for suggested packages***
software_frame = ttk.Labelframe(pwin, bootstyle="warning", text="Suggested Software")
software_frame.grid(row=0, column=0, padx=10, pady=10, sticky='ew')

pdf_viewer = ttk.Button(software_frame, text="PDF Viewer")
snap = ttk.Button(software_frame, text="Snap")
media_player = ttk.Button(software_frame, text="Media Player")
fire_wall = ttk.Button(software_frame, text="Firewall")
flatpak = ttk.Button(software_frame, text="Flatpak")
backup_tool = ttk.Button(software_frame, text="Backup Tool")
store = ttk.Button(software_frame, text="Store")

# ***GUI widgets for web browsers***
browser_frame = ttk.Labelframe(pwin, bootstyle="warning", text="Suggested Web Browsers")
browser_frame.grid(row=1, column=0, padx=10, pady=10, sticky='ew')

fire_fox = ttk.Button(browser_frame, text="Firefox")
kde_web = ttk.Button(browser_frame, text="Konqueror")
qute_web = ttk.Button(browser_frame, text="Qutebrowser")
falkon_web = ttk.Button(browser_frame, text="Falkon")
chromium_web = ttk.Button(browser_frame, text="Chromium")
gnome_web = ttk.Button(browser_frame, text="Gnome Web")

# Call the functions with the GUI widgets as arguments
check_packages(pdf_viewer, snap, media_player, fire_wall, flatpak, backup_tool, store)
check_web_browsers(fire_fox, kde_web, qute_web, falkon_web, chromium_web, gnome_web, store)


# ***Install Packages***
def install_atril():
    """ Install atril """
    subprocess.Popen(["x-terminal-emulator", "-e", "sudo", "apt", "install",
                      "atril"])
    check_packages()


def install_parole():
    """ Install parole """
    subprocess.Popen(["x-terminal-emulator", "-e", "sudo", "apt", "install",
                      "parole"])
    check_packages()


def install_gufw():
    """ Install gufw """
    subprocess.Popen(["x-terminal-emulator", "-e", "sudo", "apt", "install",
                      "gufw"])
    check_packages()


def install_snap():
    """ Install install snap"""
    subprocess.Popen(["x-terminal-emulator", "-e", "sudo", "apt", "install",
                      "snapd"])
    check_packages()


def install_flatpak():
    """ Install flatpak """
    subprocess.Popen(["x-terminal-emulator", "-e", "sudo", "apt", "install",
                      "flatpak"])
    check_packages()


def install_store():
    """ Install gnome store"""
    subprocess.Popen(["x-terminal-emulator", "-e", "sudo", "apt", "install",
                      "gnome-software"])
    check_packages()


def install_timeshift():
    """ Install timeshift"""
    subprocess.Popen(["x-terminal-emulator", "-e", "sudo", "apt", "install",
                      "timeshift"])
    check_packages()

# ***Web browser defs***
def install_firefox():
    """ Install firefox-esr """
    subprocess.Popen(["x-terminal-emulator", "-e", "sudo", "apt", "install",
                      "firefox-esr"])
    check_web_browsers()


def install_konqueror():
    """ Install konqueror """
    subprocess.Popen(["x-terminal-emulator", "-e", "sudo", "apt", "install",
                      "konqueror"])
    check_web_browsers()


def install_epiphany():
    """ Install epiphany-browser """
    subprocess.Popen(["x-terminal-emulator", "-e", "sudo", "apt", "install",
                      "epiphany-browser"])
    check_web_browsers()


def install_tor():
    """ Install torbrowser-launcher """
    subprocess.Popen(["x-terminal-emulator", "-e", "sudo", "apt", "install",
                      "torbrowser-launcher"])
    check_web_browsers()


def install_qute():
    """ Install install qutebrowser"""
    subprocess.Popen(["x-terminal-emulator", "-e", "sudo", "apt", "install",
                      "qutebrowser"])
    check_web_browsers()


def install_chromium():
    """ Install chromium"""
    subprocess.Popen(["x-terminal-emulator", "-e", "sudo", "apt", "install",
                      "chromium"])
    check_web_browsers()


def install_falkon():
    """ Install falkon"""
    subprocess.Popen(["x-terminal-emulator", "-e", "sudo", "apt", "install",
                      "falkon"])
    check_web_browsers()

# *** Below here is the layout of the forms***
center_screen()
pwin.mainloop()

